@ECHO OFF

::In Arbeitsverzeichnis wechseln
for %%i in (%0) do set PWD="%%~di%%~pi"
cd %PWD%

::Log und Bin-Verzeichnis festlegen
SET logdir=%PWD%\..\log
SET bindir=%PWD%\bin

::Prfen, ob wichtige Verzeichnis vorhanden
IF NOT EXIST %bindir% GOTO direr
IF NOT EXIST %logdir% GOTO direr

::Dienst festlegen
SET service="Firefly Media Server"
SET wait=ping -w 1000 -l 512 127.0.0.1 -n

sc query %service% | %bindir%\grep.exe -i "STATE" | %bindir%\grep.exe -q "STOPPED" && GOTO start

:stop
ECHO Ready to restart Firefly Media Server!
ECHO Stopping Serice ...
sc stop %service% > NUL

SET jahr=%date:~-4%
SET monat=%date:~-7,2%
SET tag=%date:~-10,2%
SET stunde=%time:~0,2%
SET minute=%time:~3,2%
SET sekunde=%time:~6,2%
	SET tstamp=%tag%.%monat%.%jahr% %stunde%:%minute%:%sekunde% - 

ECHO.
ECHO %tstamp% Stopping Servie >> %logdir%\firefly_restarter.txt

ECHO Waiting for the Process to shut down ...
%wait% 20 > NUL

:restart
ECHO.
ECHO.
ECHO Starting Service ...

sc start %service% > NUL

%wait% 10 > NUL

sc query %service% | %bindir%\grep.exe -q "STATE" | %bindir%\grep.exe -q "STOPPED" && GOTO retry

SET jahr=%date:~-4%
SET monat=%date:~-7,2%
SET tag=%date:~-10,2%
SET stunde=%time:~0,2%
SET minute=%time:~3,2%
SET sekunde=%time:~6,2%
	SET tstamp=%tag%.%monat%.%jahr% %stunde%:%minute%:%sekunde% - 

ECHO.
ECHO Service has been restartet without problems
ECHO %tstamp% Service has been restarted >> %logdir%\firefly_restarter.txt

%wait% 120 > NUL

:exit
EXIT

:error
SET jahr=%date:~-4%
SET monat=%date:~-7,2%
SET tag=%date:~-10,2%
SET stunde=%time:~0,2%
SET minute=%time:~3,2%
SET sekunde=%time:~6,2%
	SET tstamp=%tag%.%monat%.%jahr% %stunde%:%minute%:%sekunde% - 

ECHO Service could not be restarted without errors!
ECHO %tstamp% Service could not be restarted >> %logdir%\firefly_restarter.txt

PAUSE
GOTO exit

:direr

ECHO Error! Necessary directories are not there! Make sure to have set up a Log-Dir
ECHO and Bin-Dir with the needed files!

PAUSE
GOTO exit

:start
SET jahr=%date:~-4%
SET monat=%date:~-7,2%
SET tag=%date:~-10,2%
SET stunde=%time:~0,2%
SET minute=%time:~3,2%
SET sekunde=%time:~6,2%
	SET tstamp=%tag%.%monat%.%jahr% %stunde%:%minute%:%sekunde% - 

ECHO Service is not running! Starting Service ...
ECHO %tstamp% Service not running, starting Service >> %logdir%\firefly_restarter.txt

GOTO restart

:retry

ECHO Error! Service doesn't seem to be running, retrying..!
ECHO %tstamp% Service did not start, retrying >> %logdir%\firefly_restarter.txt
%wait% 15 > NUL

GOTO restart